package org.java.evolutionary.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;

public class Position extends GPNode{
	public static final int TOTAL_LENGTH = 238;
	public String toString() {
		return " @ ";
	}

	public void checkConstraints(final EvolutionState state, final int tree,
			final GPIndividual typicalIndividual, final Parameter individualBase) {
		super.checkConstraints(state, tree, typicalIndividual, individualBase);
		if (children.length != 1)
			state.output.error("Incorrect number of children for node "
					+ toStringForError() + " at " + individualBase);
	}

	public void eval(final EvolutionState state, final int thread,
			final GPData input, final ADFStack stack,
			final GPIndividual individual, final Problem problem) {
		int position;
		MotifData motifData = ((MotifData) (input));
		//child should give me size
		//children[0].eval(state, thread, input, stack, individual, problem);
		//if motif length is known
		int motifLength = motifData.currentMotifLength;
		//calculate a position 
		int randomPosition = state.random[thread].nextInt(TOTAL_LENGTH-motifLength);
		//say that this is what your looking for
		motifData.currentPosition = randomPosition;
	}

}
