package org.java.evolutionary.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;

public class RegionDownstreamTerminal extends GPNode{
	int startDown;
	int endDown;
	
	public String toString() { return " @ " + startDown + " " + endDown ; }
	
	public void setup(final EvolutionState state, final Parameter base)
    {
		super.setup(state, base);
		//check for where to end
		startDown = state.parameters.getInt(base.push("startDownstream"),
	            null);
		endDown = state.parameters.getInt(base.push("endDownstream"),
	            null);
		
    }
	
	public void checkConstraints(final EvolutionState state, final int tree, 
								 final GPIndividual typicalIndividual, 
								 final Parameter individualBase)
	{
		super.checkConstraints(state, tree, typicalIndividual, individualBase); 
		if (children.length!=0) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread,
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual,
					 final Problem problem) 
	{
		MotifData motifData = ((MotifData) (input));
	}

}
