package org.java.evolutionary.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;
/**
 * This generates a random Node of 1 Terminal of any combinations of {A,C,T,G} Terminal nodes.
 * @author udaykamath
 *
 */
public class StringNodeSize1 extends GPNode {
	public String toString(){
		return " motif1 ";
	}
	public void checkConstraints(final EvolutionState state, final int tree,
			final GPIndividual typicalIndividual, final Parameter individualBase) {
		super.checkConstraints(state, tree, typicalIndividual, individualBase);
		if (children.length != 1)
			state.output.error("Incorrect number of children for node "
					+ toStringForError() + " at " + individualBase);
	}

	public void eval(final EvolutionState state, final int thread,
			final GPData input, final ADFStack stack,
			final GPIndividual individual, final Problem problem) {
		int position;
		MotifData motifData = ((MotifData) (input));
		children[0].eval(state, thread, input, stack, individual, problem);
		motifData.currentMotif = Character.toString(motifData.currentTerminal).toCharArray();

	}

}
