package org.java.featurebased.kmer;


import java.util.Random;


import org.java.featurebased.AbstractFeatureBased;


public class KMerMotifFeatureGenerator extends AbstractFeatureBased {
	String[] alphabets = new String[] { "a", "t", "g", "c", };
	private boolean completed= false;
	
	
	public KMerMotifFeatureGenerator(String positiveFile, boolean fastaPositive,String negativeFile, boolean fastaNegative, String outputFile, int motifLength){
		super(positiveFile,fastaPositive,negativeFile,fastaNegative,outputFile,motifLength);
	}

	
	private String getAlphabet(Random random) {
		// generate a random number between 0 and alphabets.length
		return alphabets[random.nextInt(alphabets.length - 0)];
	}
	
	/**
	 * Given positive, negative files and kmers does quick file generation
	 * @param pos
	 * @param neg
	 * @param libSvmFile
	 * @throws Exception
	 */
	public void generateLibSVMFile() throws Exception{
		super.generateLibSVMFile();
	}

	/**
	 * Creates KMer Features based on K
	 * @param k
	 */
	public void generateFeatures()throws Exception{
		if(!completed){
			// initialize a random number
			Random random = new Random(123456789);
			// get the exponential
			double featureCount = Math.pow(alphabets.length, this.motifLength);
			double countOfFeatures = 0;
			System.out.println("Total Features: " + featureCount);
			while (countOfFeatures < featureCount) {
				StringBuffer feature = new StringBuffer();
				for (int j = 0; j < motifLength; j++) {
					feature.append(getAlphabet(random));
				}
				String motif = feature.toString();
				if (!this.features.contains(motif)) {
					this.features.add(motif);
					countOfFeatures = countOfFeatures + 1;
					System.out.println("Completed " + countOfFeatures);
				}
			}
			completed = true;
		}
	}
	
	
	public static void main(String[] args){
		if(args.length <4)
			throw new IllegalArgumentException("java KMerMotifFeatureGenerator posFile negFile outputFile KmerLength ");
		KMerMotifFeatureGenerator gen = new KMerMotifFeatureGenerator(args[0], false, args[1], false, args[2], new Integer(args[3]).intValue());
		try{
			gen.generateLibSVMFile();
			if(args.length == 7){
				//replace train with test 
				gen.changeForTest(args[4], args[5], args[6]);
				gen.generateLibSVMFile();
			}
		}catch(Throwable t){
			t.printStackTrace();
		}
	}


}
